{% trans_default_domain 'Management' %}

<script>
    let timer = null;
</script>

<div id="generals" style="display: none; overflow:auto; ">
    {% if (lord.generals|length) == 0 %}
        <p class="nothing">
            {{ 'tabs.generals.noGeneral' | trans }}
            {% if lord.city.buildingLevel('headquarters') > 0 %}
                    <ul class="actions" style="margin-left:200px;">
                        {% include 'Components/RecruitGeneralButton.html.twig' %}
                    </ul>
            {% else %}
                {{ 'tabs.generals.noHeadQuarters' | trans }}
            {% endif %}
        </p>
    {% else %}
        <table class="blocks">
            <tbody>
            <tr>
                {% set generalCount = 0 %}
                {% for general in lord.generals %}  
                    {% if generalCount%3 == 0 %}
                    </tr> <tr>
                    {% endif %}
                    {% set generalCount = generalCount+1 %}
                    <td>
                        <div class="blocks_top">
                            <h3 class="h3c">
                                {% set generalCssClass = "gdef" %}
                                {% if general.movementOrder %}
                                    {% set generalCssClass = "gmove" %}
                                {% elseif general.isFortifying %}
                                    {% set generalCssClass = "gfortify" %}
                                {% elseif general.battle != null %}
                                    {% set generalCssClass = "gbattle" %}
                                {% endif %}
                                <p class="{{ generalCssClass }}">
                                    <a href="{{ path('app_map_focusGeneral', {'worldId': lord.worldmap.id, 'generalId': general.id })}}">{{ general.name }}</a>
                                </p>
                            </h3>
                            <div class="blocks_bg">
                                <div class="blocks_bottom">
                                    <div class="p">
                                        {% if general.movementOrder %}
                                            {{ 'tabs.generals.state.movingTo' | trans(
                                                {
                                                    '%originLink%' : path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.movementOrder.origin.id }),
                                                    '%originName%' : general.movementOrder.origin.name,
                                                    '%destinationLink%' : path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.movementOrder.destination.id }),
                                                    '%destinationName%' : general.movementOrder.destination.name
                                                }) | raw
                                            }}
                                            <div>
                                                <script type="text/javascript">
                                                    let movementEndDate = "{{ general.movementOrder.travelEndDateAsString() }}";
                                                    updateTimer(movementEndDate, null);
                                                </script>
                                            </div>
                                        {% elseif general.battle != null %}
                                            {# TODO Display if the general is attacking or defending (just add a parameter?) #}
                                            {{ 'tabs.generals.state.attacking' | trans(
                                                {
                                                    '%battleLink%' : path('app_battle_battleindex', {'id': general.battle.id }),
                                                    '%locationName%' : general.location.name
                                                }) | raw
                                            }}
                                        {% elseif general.isFortifying %}
                                            {{ 'tabs.generals.state.fortifying' | trans }} <a href="{{ path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.location.id })}}">{{ general.location.name }}</a>
                                        {% else %}
                                            {{ 'tabs.generals.state.waitingAt' | trans }} <a href="{{ path('app_map_focusNode', {'worldId': lord.worldmap.id, 'nodeId': general.location.id })}}">{{ general.location.name }}</a>
                                        {% endif %}
                                    </div>
                                    <p>
                                        <img src="{{ asset('img/help.gif') }}"
                                            class="help"
                                            onmouseover="showHint(this,'{{ 'tabs.generals.reputation' | trans }}','{{ 'tabs.generals.reputationTooltip' | trans }}')"
                                            onmouseout="hideHint()">
                                        <span class="dt">{{ 'tabs.generals.reputation' | trans }}</span> :
                                            <strong>{{ general.reputation }}</strong> 
                                        <img src="{{ asset('img/icons/l_rep.png') }}">
                                    </p>
                                    <p>
                                        <img src="{{ asset('img/help.gif') }}"
                                            class="help"
                                            onmouseover="showHint(this,'{{ 'tabs.generals.maintenance' | trans }}','{{ 'tabs.generals.maintenanceTooltip' | trans }}')"
                                            onmouseout="hideHint()">
                                        <span class="dt">{{ 'tabs.generals.maintenance' | trans }}</span> :
                                            <strong>{{ general.armyCost }}</strong>
                                            <img src="{{ asset('img/icons/small/res_gold.gif') }}">
                                    </p>

                                    <ul class="ismall">
                                        {% for army in general.armyContainer.units %}
                                            {% set unitName = army.resource.name %}
                                            <li>
                                                <div class=""
                                                    onmouseover="showHint(this,'{{ ('units.'~unitName~'.name') | trans([], 'Common') }}','{{ ('units.'~unitName~'.desc') | trans([], 'Common') }}')"
                                                    onmouseout="hideHint()">
                                                    <img src="{{ asset('img/icons/small/u_'~army.resource.name~'.gif') }}" alt="">
                                                    <span class="number">{{ army.amount }}</span>
                                                </div>
                                            </li>
                                        {% endfor %}
                                    </ul>
                                    <div class="clear"></div>
                                </div>
                            </div>
                        </div>
                    </td>
                {% endfor %}
                {% if generalCount%3 == 0 %}
                    </tr> <tr>
                {% endif %}
                {% if lord.city.buildingLevel('headquarters') > lord.generals|length %}
                    <td>
                        <div class="blocks_top">
                            <ul class="actions" style="margin-left: 8px">
                                {% include 'Components/RecruitGeneralButton.html.twig' %}
                            </ul>
                        </div>
                    </td>
                {% endif %}
            </tr>
            </tbody>
        </table>
    {% endif %}
</div>


{# WHEN MOVING
<td>
									<div class="blocks_top">
										<h3 class="h3c">
											<p class="gmove">
												<a href="/map?g=1521641">symfony</a>
											</p>
										</h3>
										<div class="blocks_bg">
											<div class="blocks_bottom">
												<div class="p">
													Se déplace entre <a href="/map?c=794410">Les Toromos-les-Guibain</a> et <a href="/map?c=794450">Annomoi</a>
													<div>
                                                        <script type="text/javascript">
                                                        mt.js.Timer.TIMES="jhms";
                                                        mt.js.Timer.alloc('2021-11-06 12:18:36','2021-11-06 13:23:27',2,null);
                                                        </script>
                                                        <div id="timer_0" class="timer">1h 03m </div>
													</div>
												</div>
											<p>
#}
